/*****************************************************************************
 * vlc_threads.h : threads implementation for the VideoLAN client
 * This header provides portable declarations for mutexes & conditions
 *****************************************************************************
 * Copyright (C) 1999, 2002 the VideoLAN team
 * $Id: 2eac7f91dfa4d6781a91173175db5d2ab49ff155 $
 *
 * Authors: Jean-Marc Dressler <polux@via.ecp.fr>
 *          Samuel Hocevar <sam@via.ecp.fr>
 *          Gildas Bazin <gbazin@netcourrier.com>
 *          Christophe Massiot <massiot@via.ecp.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 *****************************************************************************/

#ifndef VLC_THREADS_H_
#define VLC_THREADS_H_

/**
 * \file
 * This file defines structures and functions for handling threads in vlc
 *
 */

#if defined( UNDER_CE )
                                                                /* WinCE API */
#elif defined( WIN32 )
#   include <process.h>                                         /* Win32 API */
#   include <errno.h>

#elif defined( SYS_BEOS )                                            /* BeOS */
#   include <kernel/OS.h>
#   include <kernel/scheduler.h>
#   include <byteorder.h>

#else                                         /* pthreads (like Linux & BSD) */
#   define LIBVLC_USE_PTHREAD 1
#   define _APPLE_C_SOURCE    1 /* Proper pthread semantics on OSX */

#   include <stdlib.h> /* lldiv_t definition (only in C99) */
#   include <unistd.h> /* _POSIX_SPIN_LOCKS */
#   include <pthread.h>
    /* Needed for pthread_cond_timedwait */
#   include <errno.h>
#   include <time.h>

#endif

/*****************************************************************************
 * Constants
 *****************************************************************************/

/* Thread priorities */
#ifdef __APPLE__
#   define VLC_THREAD_PRIORITY_LOW      0
#   define VLC_THREAD_PRIORITY_INPUT   22
#   define VLC_THREAD_PRIORITY_AUDIO   22
#   define VLC_THREAD_PRIORITY_VIDEO    0
#   define VLC_THREAD_PRIORITY_OUTPUT  22
#   define VLC_THREAD_PRIORITY_HIGHEST 22

#elif defined(SYS_BEOS)
#   define VLC_THREAD_PRIORITY_LOW 5
#   define VLC_THREAD_PRIORITY_INPUT 10
#   define VLC_THREAD_PRIORITY_AUDIO 10
#   define VLC_THREAD_PRIORITY_VIDEO 5
#   define VLC_THREAD_PRIORITY_OUTPUT 15
#   define VLC_THREAD_PRIORITY_HIGHEST 15

#elif defined(LIBVLC_USE_PTHREAD)
#   define VLC_THREAD_PRIORITY_LOW      0
#   define VLC_THREAD_PRIORITY_INPUT   10
#   define VLC_THREAD_PRIORITY_AUDIO    5
#   define VLC_THREAD_PRIORITY_VIDEO    0
#   define VLC_THREAD_PRIORITY_OUTPUT  15
#   define VLC_THREAD_PRIORITY_HIGHEST 20

#elif defined(WIN32) || defined(UNDER_CE)
/* Define different priorities for WinNT/2K/XP and Win9x/Me */
#   define VLC_THREAD_PRIORITY_LOW 0
#   define VLC_THREAD_PRIORITY_INPUT \
        (IS_WINNT ? THREAD_PRIORITY_ABOVE_NORMAL : 0)
#   define VLC_THREAD_PRIORITY_AUDIO \
        (IS_WINNT ? THREAD_PRIORITY_HIGHEST : 0)
#   define VLC_THREAD_PRIORITY_VIDEO \
        (IS_WINNT ? 0 : THREAD_PRIORITY_BELOW_NORMAL )
#   define VLC_THREAD_PRIORITY_OUTPUT \
        (IS_WINNT ? THREAD_PRIORITY_ABOVE_NORMAL : 0)
#   define VLC_THREAD_PRIORITY_HIGHEST \
        (IS_WINNT ? THREAD_PRIORITY_TIME_CRITICAL : 0)

#else
#   define VLC_THREAD_PRIORITY_LOW 0
#   define VLC_THREAD_PRIORITY_INPUT 0
#   define VLC_THREAD_PRIORITY_AUDIO 0
#   define VLC_THREAD_PRIORITY_VIDEO 0
#   define VLC_THREAD_PRIORITY_OUTPUT 0
#   define VLC_THREAD_PRIORITY_HIGHEST 0

#endif

/*****************************************************************************
 * Type definitions
 *****************************************************************************/

#if defined (LIBVLC_USE_PTHREAD)
typedef pthread_t       vlc_thread_t;
typedef pthread_mutex_t vlc_mutex_t;
typedef pthread_cond_t  vlc_cond_t;
typedef pthread_key_t   vlc_threadvar_t;

#elif defined( WIN32 ) || defined( UNDER_CE )
typedef HANDLE  vlc_thread_t;
typedef HANDLE  vlc_mutex_t;
typedef HANDLE  vlc_cond_t;
typedef DWORD   vlc_threadvar_t;

#elif defined( SYS_BEOS )
/* This is the BeOS implementation of the vlc threads, note that the mutex is
 * not a real mutex and the cond_var is not like a pthread cond_var but it is
 * enough for what we need */

typedef thread_id vlc_thread_t;

typedef struct
{
    int32_t         init;
    sem_id          lock;
} vlc_mutex_t;

typedef struct
{
    int32_t         init;
    thread_id       thread;
} vlc_cond_t;

typedef struct
{
} vlc_threadvar_t;

#endif

#if defined( WIN32 ) && !defined ETIMEDOUT
#  define ETIMEDOUT 10060 /* This is the value in winsock.h. */
#endif

#define vlc_thread_ready vlc_object_signal

/*****************************************************************************
 * vlc_mutex_lock: lock a mutex
 *****************************************************************************/
#define vlc_mutex_lock( P_MUTEX )                                           \
    __vlc_mutex_lock( __FILE__, __LINE__, P_MUTEX )


#if defined(LIBVLC_USE_PTHREAD)
# define VLC_THREAD_ASSERT( action ) \
    if (val) \
        vlc_pthread_fatal (action, val, psz_file, i_line)
#else
# define VLC_THREAD_ASSERT ((void)(val))
#endif

static inline void __vlc_mutex_lock( const char * psz_file, int i_line,
                                    vlc_mutex_t * p_mutex )
{
#if defined(LIBVLC_USE_PTHREAD)
#   define vlc_assert_locked( m ) \
           assert (pthread_mutex_lock (m) == EDEADLK)
    int val = pthread_mutex_lock( p_mutex );
    VLC_THREAD_ASSERT ("locking mutex");

#elif defined( UNDER_CE )
    (void)psz_file; (void)i_line;

    EnterCriticalSection( &p_mutex->csection );

#elif defined( WIN32 )
    (void)psz_file; (void)i_line;

    WaitForSingleObject( *p_mutex, INFINITE );

#elif defined( SYS_BEOS )
    acquire_sem( p_mutex->lock );

#endif
}

#ifndef vlc_assert_locked
# define vlc_assert_locked( m ) (void)m
#endif

/*****************************************************************************
 * vlc_mutex_unlock: unlock a mutex
 *****************************************************************************/
#define vlc_mutex_unlock( P_MUTEX )                                         \
    __vlc_mutex_unlock( __FILE__, __LINE__, P_MUTEX )

static inline void __vlc_mutex_unlock( const char * psz_file, int i_line,
                                      vlc_mutex_t *p_mutex )
{
#if defined(LIBVLC_USE_PTHREAD)
    int val = pthread_mutex_unlock( p_mutex );
    VLC_THREAD_ASSERT ("unlocking mutex");

#elif defined( UNDER_CE )
    (void)psz_file; (void)i_line;

    LeaveCriticalSection( &p_mutex->csection );

#elif defined( WIN32 )
    (void)psz_file; (void)i_line;

    ReleaseMutex( *p_mutex );

#elif defined( SYS_BEOS )
    release_sem( p_mutex->lock );

#endif
}

/*****************************************************************************
 * vlc_mutex_destroy: destroy a mutex
 *****************************************************************************/
#define vlc_mutex_destroy( P_MUTEX )                                        \
    __vlc_mutex_destroy( __FILE__, __LINE__, P_MUTEX )

/*****************************************************************************
 * vlc_cond_init: initialize a condition
 *****************************************************************************/
#define vlc_cond_init( P_THIS, P_COND )                                     \
    __vlc_cond_init( P_COND )

/*****************************************************************************
 * vlc_cond_signal: start a thread on condition completion
 *****************************************************************************/
#define vlc_cond_signal( P_COND )                                           \
    __vlc_cond_signal( __FILE__, __LINE__, P_COND )

static inline void __vlc_cond_signal( const char * psz_file, int i_line,
                                      vlc_cond_t *p_condvar )
{
#if defined(LIBVLC_USE_PTHREAD)
    int val = pthread_cond_signal( p_condvar );
    VLC_THREAD_ASSERT ("signaling condition variable");

#elif defined( UNDER_CE ) || defined( WIN32 )
    (void)psz_file; (void)i_line;

    /* Release one waiting thread if one is available. */
    /* For this trick to work properly, the vlc_cond_signal must be surrounded
     * by a mutex. This will prevent another thread from stealing the signal */
    /* PulseEvent() only works if none of the waiting threads is suspended.
     * This is particularily problematic under a debug session.
     * as documented in http://support.microsoft.com/kb/q173260/ */
    PulseEvent( *p_condvar );

#elif defined( SYS_BEOS )
    while( p_condvar->thread != -1 )
    {
        thread_info info;
        if( get_thread_info(p_condvar->thread, &info) == B_BAD_VALUE )
            return;

        if( info.state != B_THREAD_SUSPENDED )
        {
            /* The  waiting thread is not suspended so it could
             * have been interrupted beetwen the unlock and the
             * suspend_thread line. That is why we sleep a little
             * before retesting p_condver->thread. */
            snooze( 10000 );
        }
        else
        {
            /* Ok, we have to wake up that thread */
            resume_thread( p_condvar->thread );
        }
    }

#endif
}

/*****************************************************************************
 * vlc_cond_wait: wait until condition completion
 *****************************************************************************/
#define vlc_cond_wait( P_COND, P_MUTEX )                                     \
    __vlc_cond_wait( __FILE__, __LINE__, P_COND, P_MUTEX  )

static inline void __vlc_cond_wait( const char * psz_file, int i_line,
                                    vlc_cond_t *p_condvar, vlc_mutex_t *p_mutex )
{
#if defined(LIBVLC_USE_PTHREAD)
    int val = pthread_cond_wait( p_condvar, p_mutex );
    VLC_THREAD_ASSERT ("waiting on condition");

#elif defined( UNDER_CE )
    LeaveCriticalSection( &p_mutex->csection );
    WaitForSingleObject( *p_condvar, INFINITE );

    /* Reacquire the mutex before returning. */
    vlc_mutex_lock( p_mutex );

#elif defined( WIN32 )
    (void)psz_file; (void)i_line;

    /* Increase our wait count */
    SignalObjectAndWait( *p_mutex, *p_condvar, INFINITE, FALSE );

    /* Reacquire the mutex before returning. */
    vlc_mutex_lock( p_mutex );

#elif defined( SYS_BEOS )
    /* The p_condvar->thread var is initialized before the unlock because
     * it enables to identify when the thread is interrupted beetwen the
     * unlock line and the suspend_thread line */
    p_condvar->thread = find_thread( NULL );
    vlc_mutex_unlock( p_mutex );
    suspend_thread( p_condvar->thread );
    p_condvar->thread = -1;

    vlc_mutex_lock( p_mutex );

#endif
}


/*****************************************************************************
 * vlc_cond_timedwait: wait until condition completion or expiration
 *****************************************************************************
 * Returns 0 if object signaled, an error code in case of timeout or error.
 *****************************************************************************/
#define vlc_cond_timedwait( P_COND, P_MUTEX, DEADLINE )                      \
    __vlc_cond_timedwait( __FILE__, __LINE__, P_COND, P_MUTEX, DEADLINE  )

static inline int __vlc_cond_timedwait( const char * psz_file, int i_line,
                                        vlc_cond_t *p_condvar,
                                        vlc_mutex_t *p_mutex,
                                        mtime_t deadline )
{
#if defined(LIBVLC_USE_PTHREAD)
    lldiv_t d = lldiv( deadline, 1000000 );
    struct timespec ts = { d.quot, d.rem * 1000 };

    int val = pthread_cond_timedwait (p_condvar, p_mutex, &ts);
    if (val == ETIMEDOUT)
        return ETIMEDOUT; /* this error is perfectly normal */
    VLC_THREAD_ASSERT ("timed-waiting on condition");

#elif defined( UNDER_CE )
    mtime_t delay_ms = (deadline - mdate())/1000;
    DWORD result;
    if( delay_ms < 0 )
        delay_ms = 0;

    LeaveCriticalSection( &p_mutex->csection );
    result = WaitForSingleObject( *p_condvar, delay_ms );

    /* Reacquire the mutex before returning. */
    vlc_mutex_lock( p_mutex );

    if(result == WAIT_TIMEOUT)
       return ETIMEDOUT; /* this error is perfectly normal */

    (void)psz_file; (void)i_line;

#elif defined( WIN32 )
    mtime_t total = (deadline - mdate())/1000;
    DWORD result;
    if( total < 0 )
        total = 0;

    do
    {
        DWORD delay = (total > 0x7fffffff) ? 0x7fffffff : total;
        result = SignalObjectAndWait( *p_mutex, *p_condvar,
                                      delay, FALSE );
        total -= delay;
        vlc_mutex_lock (p_mutex);
    }
    while (total);

    /* Reacquire the mutex before returning. */
    if(result == WAIT_TIMEOUT)
       return ETIMEDOUT; /* this error is perfectly normal */

    (void)psz_file; (void)i_line;

#elif defined( SYS_BEOS )
#   error Unimplemented

#endif

    return 0;
}

/*****************************************************************************
 * vlc_cond_destroy: destroy a condition
 *****************************************************************************/
#define vlc_cond_destroy( P_COND )                                          \
    __vlc_cond_destroy( __FILE__, __LINE__, P_COND )

/*****************************************************************************
 * vlc_threadvar_set: create: set the value of a thread-local variable
 *****************************************************************************/
static inline int vlc_threadvar_set( vlc_threadvar_t * p_tls, void *p_value )
{
    int i_ret;

#if defined(LIBVLC_USE_PTHREAD)
    i_ret = pthread_setspecific( *p_tls, p_value );

#elif defined( SYS_BEOS )
    i_ret = EINVAL;

#elif defined( UNDER_CE ) || defined( WIN32 )
    i_ret = TlsSetValue( *p_tls, p_value ) ? EINVAL : 0;

#endif

    return i_ret;
}

/*****************************************************************************
 * vlc_threadvar_get: create: get the value of a thread-local variable
 *****************************************************************************/
static inline void* vlc_threadvar_get( vlc_threadvar_t * p_tls )
{
    void *p_ret;

#if defined(LIBVLC_USE_PTHREAD)
    p_ret = pthread_getspecific( *p_tls );

#elif defined( SYS_BEOS )
    p_ret = NULL;

#elif defined( UNDER_CE ) || defined( WIN32 )
    p_ret = TlsGetValue( *p_tls );

#endif

    return p_ret;
}

# if defined (_POSIX_SPIN_LOCKS) && ((_POSIX_SPIN_LOCKS - 0) > 0)
typedef pthread_spinlock_t vlc_spinlock_t;

/**
 * Initializes a spinlock.
 */
static inline int vlc_spin_init (vlc_spinlock_t *spin)
{
    return pthread_spin_init (spin, PTHREAD_PROCESS_PRIVATE);
}

/**
 * Acquires a spinlock.
 */
static inline void vlc_spin_lock (vlc_spinlock_t *spin)
{
    pthread_spin_lock (spin);
}

/**
 * Releases a spinlock.
 */
static inline void vlc_spin_unlock (vlc_spinlock_t *spin)
{
    pthread_spin_unlock (spin);
}

/**
 * Deinitializes a spinlock.
 */
static inline void vlc_spin_destroy (vlc_spinlock_t *spin)
{
    pthread_spin_destroy (spin);
}

#elif defined( WIN32 )

typedef CRITICAL_SECTION vlc_spinlock_t;

/**
 * Initializes a spinlock.
 */
static inline int vlc_spin_init (vlc_spinlock_t *spin)
{
    return !InitializeCriticalSectionAndSpinCount(spin, 4000);
}

/**
 * Acquires a spinlock.
 */
static inline void vlc_spin_lock (vlc_spinlock_t *spin)
{
    EnterCriticalSection(spin);
}

/**
 * Releases a spinlock.
 */
static inline void vlc_spin_unlock (vlc_spinlock_t *spin)
{
    LeaveCriticalSection(spin);
}

/**
 * Deinitializes a spinlock.
 */
static inline void vlc_spin_destroy (vlc_spinlock_t *spin)
{
    DeleteCriticalSection(spin);
}

#else

/* Fallback to plain mutexes if spinlocks are not available */
typedef vlc_mutex_t vlc_spinlock_t;

static inline int vlc_spin_init (vlc_spinlock_t *spin)
{
    return vlc_mutex_init (spin);
}

# define vlc_spin_lock    vlc_mutex_lock
# define vlc_spin_unlock  vlc_mutex_unlock
# define vlc_spin_destroy vlc_mutex_destroy
#endif

/**
 * Issues a full memory barrier.
 */
#if defined (__APPLE__)
# include <libkern/OSAtomic.h> /* OSMemoryBarrier() */
#endif
static inline void barrier (void)
{
#if defined (__GNUC__) && (__GNUC__ > 4) || (__GNUC__ == 4 && __GNUC_MINOR__ >= 1)
    __sync_synchronize ();
#elif defined(__APPLE__)
    OSMemoryBarrier ();
#elif defined(__powerpc__)
    asm volatile ("sync":::"memory");
#elif defined(__i386__)
    asm volatile ("mfence":::"memory");
#else
    vlc_spinlock_t spin;
    vlc_spin_init (&spin);
    vlc_spin_lock (&spin);
    vlc_spin_unlock (&spin);
    vlc_spin_destroy (&spin);
#endif
}

/*****************************************************************************
 * vlc_thread_create: create a thread
 *****************************************************************************/
#define vlc_thread_create( P_THIS, PSZ_NAME, FUNC, PRIORITY, WAIT )         \
    __vlc_thread_create( VLC_OBJECT(P_THIS), __FILE__, __LINE__, PSZ_NAME, FUNC, PRIORITY, WAIT )

/*****************************************************************************
 * vlc_thread_set_priority: set the priority of the calling thread
 *****************************************************************************/
#define vlc_thread_set_priority( P_THIS, PRIORITY )                         \
    __vlc_thread_set_priority( VLC_OBJECT(P_THIS), __FILE__, __LINE__, PRIORITY )

/*****************************************************************************
 * vlc_thread_join: wait until a thread exits
 *****************************************************************************/
#define vlc_thread_join( P_THIS )                                           \
    __vlc_thread_join( VLC_OBJECT(P_THIS), __FILE__, __LINE__ )

#endif /* !_VLC_THREADS_H */

#if defined( __cplusplus )
extern "C" {
#endif



#define VLC_THREADS_UNINITIALIZED  0
#define VLC_THREADS_PENDING        1
#define VLC_THREADS_ERROR          2
#define VLC_THREADS_READY          3

/*****************************************************************************
* Global mutex for lazy initialization of the threads system
*****************************************************************************/
static volatile unsigned i_initializations = 0;

#if defined( LIBVLC_USE_PTHREAD )
# include <sched.h>

static pthread_mutex_t once_mutex = PTHREAD_MUTEX_INITIALIZER;
#endif

/**
* Global process-wide VLC object.
* Contains inter-instance data, such as the module cache and global mutexes.
*/
static libvlc_global_data_t *p_root;

libvlc_global_data_t *vlc_global( void )
{
	assert( i_initializations > 0 );
	return p_root;
}

#ifndef NDEBUG
/**
* Object running the current thread
*/
static vlc_threadvar_t thread_object_key;

vlc_object_t *vlc_threadobj (void)
{
	return vlc_threadvar_get (&thread_object_key);
}
#endif

vlc_threadvar_t msg_context_global_key;

#if defined(LIBVLC_USE_PTHREAD)
static inline unsigned long vlc_threadid (void)
{
	union { pthread_t th; unsigned long int i; } v = { };
	v.th = pthread_self ();
	return v.i;
}

#if defined(HAVE_EXECINFO_H) && defined(HAVE_BACKTRACE)
# include <execinfo.h>
#endif

/*****************************************************************************
* vlc_thread_fatal: Report an error from the threading layer
*****************************************************************************
* This is mostly meant for debugging.
*****************************************************************************/
void vlc_pthread_fatal (const char *action, int error,
	const char *file, unsigned line)
{
	fprintf (stderr, "LibVLC fatal error %s in thread %lu at %s:%u: %d\n",
		action, vlc_threadid (), file, line, error);

	/* Sometimes strerror_r() crashes too, so make sure we print an error
	* message before we invoke it */
#ifdef __GLIBC__
	/* Avoid the strerror_r() prototype brain damage in glibc */
	errno = error;
	fprintf (stderr, " Error message: %m at:\n");
#else
	char buf[1000];
	const char *msg;

	switch (strerror_r (error, buf, sizeof (buf)))
	{
	case 0:
		msg = buf;
		break;
	case ERANGE: /* should never happen */
		msg = "unknwon (too big to display)";
		break;
	default:
		msg = "unknown (invalid error number)";
		break;
	}
	fprintf (stderr, " Error message: %s\n", msg);
#endif
	fflush (stderr);

#ifdef HAVE_BACKTRACE
	void *stack[20];
	int len = backtrace (stack, sizeof (stack) / sizeof (stack[0]));
	backtrace_symbols_fd (stack, len, 2);
#endif

	abort ();
}
#else
void vlc_pthread_fatal (const char *action, int error,
	const char *file, unsigned line)
{
	(void)action; (void)error; (void)file; (void)line;
	abort();
}
#endif

/*****************************************************************************
* vlc_threads_init: initialize threads system
*****************************************************************************
* This function requires lazy initialization of a global lock in order to
* keep the library really thread-safe. Some architectures don't support this
* and thus do not guarantee the complete reentrancy.
*****************************************************************************/
int vlc_threads_init( void )
{
	int i_ret = VLC_SUCCESS;

	/* If we have lazy mutex initialization, use it. Otherwise, we just
	* hope nothing wrong happens. */
#if defined( LIBVLC_USE_PTHREAD )
	pthread_mutex_lock( &once_mutex );
#endif

	if( i_initializations == 0 )
	{
		p_root = vlc_custom_create( (vlc_object_t *)NULL, sizeof( *p_root ),
			VLC_OBJECT_GENERIC, "root" );
		if( p_root == NULL )
		{
			i_ret = VLC_ENOMEM;
			goto out;
		}

		/* We should be safe now. Do all the initialization stuff we want. */
#ifndef NDEBUG
		vlc_threadvar_create( &thread_object_key, NULL );
#endif
		vlc_threadvar_create( &msg_context_global_key, msg_StackDestroy );
	}
	i_initializations++;

out:
	/* If we have lazy mutex initialization support, unlock the mutex.
	* Otherwize, we are screwed. */
#if defined( LIBVLC_USE_PTHREAD )
	pthread_mutex_unlock( &once_mutex );
#endif

	return i_ret;
}

/*****************************************************************************
* vlc_threads_end: stop threads system
*****************************************************************************
* FIXME: This function is far from being threadsafe.
*****************************************************************************/
void vlc_threads_end( void )
{
#if defined( LIBVLC_USE_PTHREAD )
	pthread_mutex_lock( &once_mutex );
#endif

	assert( i_initializations > 0 );

	if( i_initializations == 1 )
	{
		vlc_object_release( p_root );
		vlc_threadvar_delete( &msg_context_global_key );
#ifndef NDEBUG
		vlc_threadvar_delete( &thread_object_key );
#endif
	}
	i_initializations--;

#if defined( LIBVLC_USE_PTHREAD )
	pthread_mutex_unlock( &once_mutex );
#endif
}

#if defined (__GLIBC__) && (__GLIBC_MINOR__ < 6)
/* This is not prototyped under glibc, though it exists. */
int pthread_mutexattr_setkind_np( pthread_mutexattr_t *attr, int kind );
#endif

/*****************************************************************************
* vlc_mutex_init: initialize a mutex
*****************************************************************************/
int vlc_mutex_init( vlc_mutex_t *p_mutex )
{
#if defined( LIBVLC_USE_PTHREAD )
	pthread_mutexattr_t attr;
	int                 i_result;

	pthread_mutexattr_init( &attr );

# ifndef NDEBUG
	/* Create error-checking mutex to detect problems more easily. */
#  if defined (__GLIBC__) && (__GLIBC_MINOR__ < 6)
	pthread_mutexattr_setkind_np( &attr, PTHREAD_MUTEX_ERRORCHECK_NP );
#  else
	pthread_mutexattr_settype( &attr, PTHREAD_MUTEX_ERRORCHECK );
#  endif
# endif
	i_result = pthread_mutex_init( p_mutex, &attr );
	pthread_mutexattr_destroy( &attr );
	return i_result;
#elif defined( UNDER_CE )
	InitializeCriticalSection( &p_mutex->csection );
	return 0;

#elif defined( WIN32 )
	*p_mutex = CreateMutex( NULL, FALSE, NULL );
	return (*p_mutex != NULL) ? 0 : ENOMEM;

#elif defined( HAVE_KERNEL_SCHEDULER_H )
	/* check the arguments and whether it's already been initialized */
	if( p_mutex == NULL )
	{
		return B_BAD_VALUE;
	}

	if( p_mutex->init == 9999 )
	{
		return EALREADY;
	}

	p_mutex->lock = create_sem( 1, "BeMutex" );
	if( p_mutex->lock < B_NO_ERROR )
	{
		return( -1 );
	}

	p_mutex->init = 9999;
	return B_OK;

#endif
}

/*****************************************************************************
* vlc_mutex_init: initialize a recursive mutex (Do not use)
*****************************************************************************/
int vlc_mutex_init_recursive( vlc_mutex_t *p_mutex )
{
#if defined( LIBVLC_USE_PTHREAD )
	pthread_mutexattr_t attr;
	int                 i_result;

	pthread_mutexattr_init( &attr );
#  if defined (__GLIBC__) && (__GLIBC_MINOR__ < 6)
	pthread_mutexattr_setkind_np( &attr, PTHREAD_MUTEX_RECURSIVE_NP );
#  else
	pthread_mutexattr_settype( &attr, PTHREAD_MUTEX_RECURSIVE );
#  endif
	i_result = pthread_mutex_init( p_mutex, &attr );
	pthread_mutexattr_destroy( &attr );
	return( i_result );
#elif defined( WIN32 )
	/* Create mutex returns a recursive mutex */
	*p_mutex = CreateMutex( 0, FALSE, 0 );
	return (*p_mutex != NULL) ? 0 : ENOMEM;
#else
# error Unimplemented!
#endif
}


/*****************************************************************************
* vlc_mutex_destroy: destroy a mutex, inner version
*****************************************************************************/
void __vlc_mutex_destroy( const char * psz_file, int i_line, vlc_mutex_t *p_mutex )
{
#if defined( LIBVLC_USE_PTHREAD )
	int val = pthread_mutex_destroy( p_mutex );
	VLC_THREAD_ASSERT ("destroying mutex");

#elif defined( UNDER_CE )
	VLC_UNUSED( psz_file); VLC_UNUSED( i_line );

	DeleteCriticalSection( &p_mutex->csection );

#elif defined( WIN32 )
	VLC_UNUSED( psz_file); VLC_UNUSED( i_line );

	CloseHandle( *p_mutex );

#elif defined( HAVE_KERNEL_SCHEDULER_H )
	if( p_mutex->init == 9999 )
		delete_sem( p_mutex->lock );

	p_mutex->init = 0;

#endif
}

/*****************************************************************************
* vlc_cond_init: initialize a condition
*****************************************************************************/
int __vlc_cond_init( vlc_cond_t *p_condvar )
{
#if defined( LIBVLC_USE_PTHREAD )
	pthread_condattr_t attr;
	int ret;

	ret = pthread_condattr_init (&attr);
	if (ret)
		return ret;

# if !defined (_POSIX_CLOCK_SELECTION)
	/* Fairly outdated POSIX support (that was defined in 2001) */
#  define _POSIX_CLOCK_SELECTION (-1)
# endif
# if (_POSIX_CLOCK_SELECTION >= 0)
	/* NOTE: This must be the same clock as the one in mtime.c */
	pthread_condattr_setclock (&attr, CLOCK_MONOTONIC);
# endif

	ret = pthread_cond_init (p_condvar, &attr);
	pthread_condattr_destroy (&attr);
	return ret;

#elif defined( UNDER_CE ) || defined( WIN32 )
	/* Create an auto-reset event. */
	*p_condvar = CreateEvent( NULL,   /* no security */
		FALSE,  /* auto-reset event */
		FALSE,  /* start non-signaled */
		NULL ); /* unnamed */
	return *p_condvar ? 0 : ENOMEM;

#elif defined( HAVE_KERNEL_SCHEDULER_H )
	if( !p_condvar )
	{
		return B_BAD_VALUE;
	}

	if( p_condvar->init == 9999 )
	{
		return EALREADY;
	}

	p_condvar->thread = -1;
	p_condvar->init = 9999;
	return 0;

#endif
}

/*****************************************************************************
* vlc_cond_destroy: destroy a condition, inner version
*****************************************************************************/
void __vlc_cond_destroy( const char * psz_file, int i_line, vlc_cond_t *p_condvar )
{
#if defined( LIBVLC_USE_PTHREAD )
	int val = pthread_cond_destroy( p_condvar );
	VLC_THREAD_ASSERT ("destroying condition");

#elif defined( UNDER_CE ) || defined( WIN32 )
	VLC_UNUSED( psz_file); VLC_UNUSED( i_line );

	CloseHandle( *p_condvar );

#elif defined( HAVE_KERNEL_SCHEDULER_H )
	p_condvar->init = 0;

#endif
}

/*****************************************************************************
* vlc_tls_create: create a thread-local variable
*****************************************************************************/
int vlc_threadvar_create( vlc_threadvar_t *p_tls, void (*destr) (void *) )
{
	int i_ret;

#if defined( LIBVLC_USE_PTHREAD )
	i_ret =  pthread_key_create( p_tls, destr );
#elif defined( UNDER_CE )
	i_ret = ENOSYS;
#elif defined( WIN32 )
	/* FIXME: remember/use the destr() callback and stop leaking whatever */
	*p_tls = TlsAlloc();
	i_ret = (*p_tls == TLS_OUT_OF_INDEXES) ? EAGAIN : 0;
#else
# error Unimplemented!
#endif
	return i_ret;
}

void vlc_threadvar_delete (vlc_threadvar_t *p_tls)
{
#if defined( LIBVLC_USE_PTHREAD )
	pthread_key_delete (*p_tls);
#elif defined( UNDER_CE )
#elif defined( WIN32 )
	TlsFree (*p_tls);
#else
# error Unimplemented!
#endif
}

struct vlc_thread_boot
{
	void * (*entry) (vlc_object_t *);
	vlc_object_t *object;
};

#if defined (LIBVLC_USE_PTHREAD)
# define THREAD_RTYPE void *
# define THREAD_RVAL  NULL
#elif defined (WIN32)
# define THREAD_RTYPE __stdcall unsigned
# define THREAD_RVAL 0
#endif

static THREAD_RTYPE thread_entry (void *data)
{
	vlc_object_t *obj = ((struct vlc_thread_boot *)data)->object;
	void *(*func) (vlc_object_t *) = ((struct vlc_thread_boot *)data)->entry;

	free (data);
#ifndef NDEBUG
	vlc_threadvar_set (&thread_object_key, obj);
#endif
	msg_Dbg (obj, "thread started");
	func (obj);
	msg_Dbg (obj, "thread ended");

	return THREAD_RVAL;
}

/*****************************************************************************
* vlc_thread_create: create a thread, inner version
*****************************************************************************
* Note that i_priority is only taken into account on platforms supporting
* userland real-time priority threads.
*****************************************************************************/
int __vlc_thread_create( vlc_object_t *p_this, const char * psz_file, int i_line,
	const char *psz_name, void * ( *func ) ( vlc_object_t * ),
	int i_priority, bool b_wait )
{
	int i_ret;
	vlc_object_internals_t *p_priv = vlc_internals( p_this );

	struct vlc_thread_boot *boot = malloc (sizeof (*boot));
	if (boot == NULL)
		return errno;
	boot->entry = func;
	boot->object = p_this;

	vlc_object_lock( p_this );

	/* Make sure we don't re-create a thread if the object has already one */
	assert( !p_priv->b_thread );

#if defined( LIBVLC_USE_PTHREAD )
	pthread_attr_t attr;
	pthread_attr_init (&attr);

	/* Block the signals that signals interface plugin handles.
	* If the LibVLC caller wants to handle some signals by itself, it should
	* block these before whenever invoking LibVLC. And it must obviously not
	* start the VLC signals interface plugin.
	*
	* LibVLC will normally ignore any interruption caused by an asynchronous
	* signal during a system call. But there may well be some buggy cases
	* where it fails to handle EINTR (bug reports welcome). Some underlying
	* libraries might also not handle EINTR properly.
	*/
	sigset_t set, oldset;
	sigemptyset (&set);
	sigdelset (&set, SIGHUP);
	sigaddset (&set, SIGINT);
	sigaddset (&set, SIGQUIT);
	sigaddset (&set, SIGTERM);

	sigaddset (&set, SIGPIPE); /* We don't want this one, really! */
	pthread_sigmask (SIG_BLOCK, &set, &oldset);

#ifndef __APPLE__
	if( config_GetInt( p_this, "rt-priority" ) > 0 )
#endif
	{
		struct sched_param p = { .sched_priority = i_priority, };
		int policy;

		/* Hack to avoid error msg */
		if( config_GetType( p_this, "rt-offset" ) )
			p.sched_priority += config_GetInt( p_this, "rt-offset" );
		if( p.sched_priority <= 0 )
			p.sched_priority += sched_get_priority_max (policy = SCHED_OTHER);
		else
			p.sched_priority += sched_get_priority_min (policy = SCHED_RR);

		pthread_attr_setschedpolicy (&attr, policy);
		pthread_attr_setschedparam (&attr, &p);
	}

	i_ret = pthread_create( &p_priv->thread_id, &attr, thread_entry, boot );
	pthread_sigmask (SIG_SETMASK, &oldset, NULL);
	pthread_attr_destroy (&attr);

#elif defined( WIN32 ) || defined( UNDER_CE )
	/* When using the MSVCRT C library you have to use the _beginthreadex
	* function instead of CreateThread, otherwise you'll end up with
	* memory leaks and the signal functions not working (see Microsoft
	* Knowledge Base, article 104641) */
#if defined( UNDER_CE )
	HANDLE hThread = CreateThread( NULL, 0, thread_entry,
		(LPVOID)boot, CREATE_SUSPENDED, NULL );
#else
	HANDLE hThread = (HANDLE)(uintptr_t)
		_beginthreadex( NULL, 0, thread_entry, boot, CREATE_SUSPENDED, NULL );
#endif
	if( hThread )
	{
		p_priv->thread_id = hThread;
		ResumeThread (hThread);
		i_ret = 0;
		if( i_priority && !SetThreadPriority (hThread, i_priority) )
		{
			msg_Warn( p_this, "couldn't set a faster priority" );
			i_priority = 0;
		}
	}
	else
		i_ret = errno;

#elif defined( HAVE_KERNEL_SCHEDULER_H )
	p_priv->thread_id = spawn_thread( (thread_func)thread_entry, psz_name,
		i_priority, p_data );
	i_ret = resume_thread( p_priv->thread_id );

#endif

	if( i_ret == 0 )
	{
		if( b_wait )
		{
			msg_Dbg( p_this, "waiting for thread initialization" );
			vlc_object_wait( p_this );
		}

		p_priv->b_thread = true;
		msg_Dbg( p_this, "thread %lu (%s) created at priority %d (%s:%d)",
			(unsigned long)p_priv->thread_id, psz_name, i_priority,
			psz_file, i_line );
	}
	else
	{
		errno = i_ret;
		msg_Err( p_this, "%s thread could not be created at %s:%d (%m)",
			psz_name, psz_file, i_line );
	}

	vlc_object_unlock( p_this );
	return i_ret;
}

/*****************************************************************************
* vlc_thread_set_priority: set the priority of the current thread when we
* couldn't set it in vlc_thread_create (for instance for the main thread)
*****************************************************************************/
int __vlc_thread_set_priority( vlc_object_t *p_this, const char * psz_file,
	int i_line, int i_priority )
{
	vlc_object_internals_t *p_priv = vlc_internals( p_this );

	if( !p_priv->b_thread )
	{
		msg_Err( p_this, "couldn't set priority of non-existent thread" );
		return ESRCH;
	}

#if defined( LIBVLC_USE_PTHREAD )
# ifndef __APPLE__
	if( config_GetInt( p_this, "rt-priority" ) > 0 )
# endif
	{
		int i_error, i_policy;
		struct sched_param param;

		memset( &param, 0, sizeof(struct sched_param) );
		if( config_GetType( p_this, "rt-offset" ) )
			i_priority += config_GetInt( p_this, "rt-offset" );
		if( i_priority <= 0 )
		{
			param.sched_priority = (-1) * i_priority;
			i_policy = SCHED_OTHER;
		}
		else
		{
			param.sched_priority = i_priority;
			i_policy = SCHED_RR;
		}
		if( (i_error = pthread_setschedparam( p_priv->thread_id,
			i_policy, &param )) )
		{
			errno = i_error;
			msg_Warn( p_this, "couldn't set thread priority (%s:%d): %m",
				psz_file, i_line );
			i_priority = 0;
		}
	}

#elif defined( WIN32 ) || defined( UNDER_CE )
	VLC_UNUSED( psz_file); VLC_UNUSED( i_line );

	if( !SetThreadPriority(p_priv->thread_id, i_priority) )
	{
		msg_Warn( p_this, "couldn't set a faster priority" );
		return 1;
	}

#endif

	return 0;
}

/*****************************************************************************
* vlc_thread_join: wait until a thread exits, inner version
*****************************************************************************/
void __vlc_thread_join( vlc_object_t *p_this, const char * psz_file, int i_line )
{
	vlc_object_internals_t *p_priv = vlc_internals( p_this );
	int i_ret = 0;

#if defined( LIBVLC_USE_PTHREAD )
	/* Make sure we do return if we are calling vlc_thread_join()
	* from the joined thread */
	if (pthread_equal (pthread_self (), p_priv->thread_id))
	{
		msg_Warn (p_this, "joining the active thread (VLC might crash)");
		i_ret = pthread_detach (p_priv->thread_id);
	}
	else
		i_ret = pthread_join (p_priv->thread_id, NULL);

#elif defined( UNDER_CE ) || defined( WIN32 )
	HMODULE hmodule;
	BOOL (WINAPI *OurGetThreadTimes)( HANDLE, FILETIME*, FILETIME*,
		FILETIME*, FILETIME* );
	FILETIME create_ft, exit_ft, kernel_ft, user_ft;
	int64_t real_time, kernel_time, user_time;
	HANDLE hThread;

	/*
	** object will close its thread handle when destroyed, duplicate it here
	** to be on the safe side
	*/
	if( ! DuplicateHandle(GetCurrentProcess(),
		p_priv->thread_id,
		GetCurrentProcess(),
		&hThread,
		0,
		FALSE,
		DUPLICATE_SAME_ACCESS) )
	{
		p_priv->b_thread = false;
		i_ret = GetLastError();
		goto error;
	}

	WaitForSingleObject( hThread, INFINITE );

#if defined( UNDER_CE )
	hmodule = GetModuleHandle( _T("COREDLL") );
#else
	hmodule = GetModuleHandle( _T("KERNEL32") );
#endif
	OurGetThreadTimes = (BOOL (WINAPI*)( HANDLE, FILETIME*, FILETIME*,
		FILETIME*, FILETIME* ))
		GetProcAddress( hmodule, _T("GetThreadTimes") );

	if( OurGetThreadTimes &&
		OurGetThreadTimes( hThread,
		&create_ft, &exit_ft, &kernel_ft, &user_ft ) )
	{
		real_time =
			((((int64_t)exit_ft.dwHighDateTime)<<32)| exit_ft.dwLowDateTime) -
			((((int64_t)create_ft.dwHighDateTime)<<32)| create_ft.dwLowDateTime);
		real_time /= 10;

		kernel_time =
			((((int64_t)kernel_ft.dwHighDateTime)<<32)|
			kernel_ft.dwLowDateTime) / 10;

		user_time =
			((((int64_t)user_ft.dwHighDateTime)<<32)|
			user_ft.dwLowDateTime) / 10;

		msg_Dbg( p_this, "thread times: "
			"real %"PRId64"m%fs, kernel %"PRId64"m%fs, user %"PRId64"m%fs",
			real_time/60/1000000,
			(double)((real_time%(60*1000000))/1000000.0),
			kernel_time/60/1000000,
			(double)((kernel_time%(60*1000000))/1000000.0),
			user_time/60/1000000,
			(double)((user_time%(60*1000000))/1000000.0) );
	}
	CloseHandle( hThread );
error:

#elif defined( HAVE_KERNEL_SCHEDULER_H )
	int32_t exit_value;
	i_ret = (B_OK == wait_for_thread( p_priv->thread_id, &exit_value ));

#endif

	if( i_ret )
	{
		errno = i_ret;
		msg_Err( p_this, "thread_join(%lu) failed at %s:%d (%m)",
			(unsigned long)p_priv->thread_id, psz_file, i_line );
	}
	else
		msg_Dbg( p_this, "thread %lu joined (%s:%d)",
		(unsigned long)p_priv->thread_id, psz_file, i_line );

	p_priv->b_thread = false;
}

#if defined( __cplusplus )
}
#endif